#Copyright (c) 2015 3D Control Systems LTD

#3DPrinterOS client is free software: you can redistribute it and/or modify
#it under the terms of the GNU Affero General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.

#3DPrinterOS client is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU Affero General Public License for more details.

#You should have received a copy of the GNU Affero General Public License
#along with 3DPrinterOS client.  If not, see <http://www.gnu.org/licenses/>.

# Author: Vladimir Avdeev <another.vic@yandex.ru>

import os
import sys
import os.path
import subprocess

import config
import platforms

class TrayController:

    def __init__(self):
        self.tray_process = self.start()

    def start(self):
        tray_settings = config.get_settings().get('tray_icon')
        if tray_settings.get('enabled'):
            if platforms.PLATFORM == 'mac':
                module_name = 'mac_tray.py'
            elif platforms.PLATFORM == 'win':
                module_name = 'wx_tray.py'
            elif platforms.PLATFORM == 'linux':
                module_name = 'gtk_tray.py'
            else:
                module_name = None
            if module_name:
                module_path = os.path.join(os.path.dirname(os.path.abspath(__file__)), module_name)
                return subprocess.Popen([sys.executable, module_path], close_fds=True)

    def stop(self):
        if self.tray_process:
            try:
                self.tray_process.terminate()
            except:
                pass
